public class TripState { 
    int startTime;
    int tripState;
    int tripNo;
    int suspendTime;
    int baseTime;

    static final int FINISHED          = 0;
    static final int NEW_TRIP          = 1;    
    static final int NAVIGATE_FORWARD  = 2;
    static final int NAVIGATE_BACKWARD = 3;


    byte[] pack() { 
        byte[] buf = new byte[17];
        Converter.packInt(buf, 0, startTime);
        Converter.packInt(buf, 4, tripNo);
        Converter.packInt(buf, 8, suspendTime);
        Converter.packInt(buf, 12, baseTime);
        buf[16]= (byte)tripState;
        return buf;
    }

    void unpack(byte[] buf) { 
        startTime = Converter.unpackInt(buf, 0);
        tripNo = Converter.unpackInt(buf, 4);
        suspendTime = Converter.unpackInt(buf, 8);
        baseTime = Converter.unpackInt(buf, 12);
        tripState = buf[16];
    }
}