import javax.microedition.lcdui.*;

public class AddTripForm extends TextBox implements CommandListener
{ 
    TripMate main;
    
    AddTripForm(TripMate main) 
    {
        super("Trip description", "", 256, TextField.ANY);        
        this.main = main;
        setCommandListener(this);
        addCommand(TripMate.ENTER_CMD);
        addCommand(TripMate.BACK_CMD);
        Display.getDisplay(main).setCurrent(this);
    }
           
    public void commandAction(Command c, Displayable d) 
    {    
        if (c == TripMate.ENTER_CMD) {
            Trip trip = new Trip(getString(), (int)(System.currentTimeMillis()/1000));
            main.addTrip(trip);
            main.mainMenu.insert(0, trip.description, null);
            main.state.tripState = TripState.NEW_TRIP;
            main.updateState();
            new AddPointForm(trip, main);
        } else { 
            Display.getDisplay(main).setCurrent(main.mainMenu);
        }
    }
}